%global pypi_name pinakes
%global product_name automation-services-catalog
%global ui_name automation-catalog-ui
%global approval_ui_name automation-catalog-approval-ui
%global commitId_pinakes 8633a9d78c02c27337c8b4b7efaf2ff600c30119
%global commitId_catalog_ui a6dd49c7e9b783084c8b114d7161cf6900d62f8a
%global commitId_approval_ui 565526886eeb659a4d8da9b3c5d1818a09749994
%global debug_package %{nil}

Name:           %{product_name}
Version:        1.0.6
Release:        1%{?dist}
Summary:        Red Hat Ansible Automation Platform Services Catalog

License:        ASL 2.0
URL:            https://github.com/ansible/pinakes.git
Source0:        pinakes-8633a9d78c02c27337c8b4b7efaf2ff600c30119.tar.gz
Source1:        automation-catalog-ui-a6dd49c7e9b783084c8b114d7161cf6900d62f8a.tar.gz
Source2:        automation-catalog-approval-ui-565526886eeb659a4d8da9b3c5d1818a09749994.tar.gz
Source3:        automation-services-catalog.service
Source4:        automation-services-catalog-worker.service
Source5:        automation-services-catalog-scheduler.service
Source6:        image_overrides.tar.xz
Source7:        automation-services-catalog.socket
Patch1:         pinakes-webpack-Avoid-md4-hash-for-OpenSSL-3.patch
Patch2:         insights-webpack-Avoid-md4-hash-for-OpenSSL-3.patch
BuildArch:      x86_64

BuildRequires:  cairo-devel
BuildRequires:  gcc-c++
BuildRequires:  giflib-devel
BuildRequires:  libjpeg-devel
BuildRequires:  make
BuildRequires:  nodejs-devel
BuildRequires:  npm
BuildRequires:  pango-devel
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-pbr
BuildRequires:  python%{python3_pkgversion}-rpm-macros
BuildRequires:  python%{python3_pkgversion}-setuptools
BuildRequires:  systemd

BuildRequires: /usr/bin/pathfix.py

%{?python_provide:%python_provide python%{python3_pkgversion}-%{pypi_name}}
Requires:  ansible-automation-platform-common
Requires:  nginx
Requires:  postgresql
Requires:  python%{python3_pkgversion}-dateutil
Requires:  python%{python3_pkgversion}-django
Requires:  python%{python3_pkgversion}-django-cors-headers
Requires:  python%{python3_pkgversion}-django-environ
Requires:  python%{python3_pkgversion}-django-filter
Requires:  python%{python3_pkgversion}-django-rq
Requires:  python%{python3_pkgversion}-django-taggit
Requires:  python%{python3_pkgversion}-djangorestframework
Requires:  python%{python3_pkgversion}-drf-extensions
Requires:  python%{python3_pkgversion}-drf-spectacular
Requires:  python%{python3_pkgversion}-gunicorn
Requires:  python%{python3_pkgversion}-insights-analytics-collector
# python-jose needed for social-auth-core[openidconnect]
Requires:  python%{python3_pkgversion}-jose
Requires:  python%{python3_pkgversion}-pillow
Requires:  python%{python3_pkgversion}-psycopg2
Requires:  python%{python3_pkgversion}-pydantic
Requires:  python%{python3_pkgversion}-pytz
Requires:  python%{python3_pkgversion}-requests
Requires:  python%{python3_pkgversion}-rq-scheduler
Requires:  python%{python3_pkgversion}-social-auth-app-django
Requires:  python%{python3_pkgversion}-social-auth-core
Requires:  python3-libsemanage
Requires:  redis
Requires:  rsyslog
Requires:  sos
Requires:  systemd

%description
Ansible Automation Services Catalog allows customers to expose their Ansible
Job Templates and Workflows to business users with an added layer of governance.
The Job Templates and Workflows are wrapped as Products into Portfolios which
can be shared with different business users. An approval workflow can be
attached to Products or Portfolios which adds governance and, in the future,
will be able to notify the appropriate Administrators via email. Upon approval,
the Job Template or workflow will be launched on the Ansible Controller.

%prep
%setup -q -T -b 1 -n automation-catalog-ui-%{commitId_catalog_ui}
%patch -P 1 -p1
%setup -q -T -b 2 -n automation-catalog-approval-ui-%{commitId_approval_ui}
%patch -P 2 -p1
%setup -q -T -a 6 -c -n automation-catalog-ui-productization
%setup -q -n %{pypi_name}-%{commitId_pinakes}

# Fix all Python shebangs recursively in .
pathfix.py -pni "%{__python3} %{py3_shbang_opts}" .

%build
export PBR_VERSION=%{version}
%{py3_build}

# init npm
npm_registry_override="https://repository.engineering.redhat.com/nexus/repository/registry.npmjs.org/"
npm config set registry ${npm_registry_override}
npm config set strict-ssl false
npm config set nodedir %{_exec_prefix}
npm install --prefix %{_builddir}/npm8 npm@8
export PATH=%{_builddir}/npm8/node_modules/npm/bin/npm:$PATH

# build catalog-ui
cd %{_builddir}/%{ui_name}-%{commitId_catalog_ui}
cp %{_builddir}/automation-catalog-ui-productization/pinakes/* %{_builddir}/%{ui_name}-%{commitId_catalog_ui}/src/assets/images/
sed -i "s#https\?://registry.npmjs.org#${npm_registry_override}#g" package-lock.json
npm install --build-from-source
APPLICATION_NAME='Automation Services Catalog' npm run build:standalone

# build approval-ui
cd %{_builddir}/%{approval_ui_name}-%{commitId_approval_ui}
cp %{_builddir}/automation-catalog-ui-productization/approval/* %{_builddir}/%{approval_ui_name}-%{commitId_approval_ui}/src/assets/images/
sed -i "s#https\?://registry.npmjs.org#${npm_registry_override}#g" package-lock.json
npm install --build-from-source
APPLICATION_NAME='Automation Services Catalog' npm run build:standalone

%install
install -m 0755 -vd                     %{buildroot}%{_unitdir}

# add system unit files
install -m 644 %{SOURCE3}               %{buildroot}%{_unitdir}
install -m 644 %{SOURCE4}               %{buildroot}%{_unitdir}
install -m 644 %{SOURCE5}               %{buildroot}%{_unitdir}
install -m 644 %{SOURCE7}               %{buildroot}%{_unitdir}

# install ui
mkdir -p %{buildroot}%{python3_sitelib}/%{pypi_name}/ui/catalog/approval/
cp -a %{_builddir}/%{ui_name}-%{commitId_catalog_ui}/dist/* %{buildroot}%{python3_sitelib}/%{pypi_name}/ui/catalog/
cp -a %{_builddir}/%{approval_ui_name}-%{commitId_approval_ui}/dist/* %{buildroot}%{python3_sitelib}/%{pypi_name}/ui/catalog/approval/

# add manage script to reasonable location
mkdir -p %{buildroot}%{_sharedstatedir}/ansible-automation-platform/services-catalog
cp -a manage.py %{buildroot}%{_sharedstatedir}/ansible-automation-platform/services-catalog/

# add configuration directory
mkdir -p %{buildroot}%{_sysconfdir}/ansible-automation-platform/services-catalog

# add directory for sockets
mkdir -p %{buildroot}%{_rundir}/ansible-automation-platform

# install pinakes
export PBR_VERSION=%{version}
%{py3_install}

%pre
getent group pinakes >/dev/null || groupadd -r pinakes
getent passwd pinakes >/dev/null || \
    useradd -r -g pinakes -G nginx -d %{_sharedstatedir}/ansible-automation-platform/services-catalog -s %{_bindir}/bash pinakes

%files
%defattr(-,root,root)
%{python3_sitelib}/%{pypi_name}
%{python3_sitelib}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

%{_unitdir}/automation-services-catalog.service
%{_unitdir}/automation-services-catalog.socket
%{_unitdir}/automation-services-catalog-worker.service
%{_unitdir}/automation-services-catalog-scheduler.service

%attr(0755,pinakes,pinakes) %{_sharedstatedir}/ansible-automation-platform/services-catalog
%attr(0750,pinakes,root) %{_sysconfdir}/ansible-automation-platform/services-catalog
%attr(2775,nginx,nginx) %{_rundir}/ansible-automation-platform

%changelog
* Thu May 12 2022 Yanis Guenane <yguenane@redhat.com> - 1.0.6-1
- Initial package
